import java.io.*;
import java.util.*;

public class TestGen {

    static PrintWriter out;
    static Random rnd = new Random(0);
    static int tNumber = 1;
    static PrintWriter testDescr;
    static int sb = 0;


    static void printTest(int n, int k, ArrayList<Pair> arr, String comment) throws IOException {
        System.out.println(String.format("Generating test %d", tNumber));
        if (tNumber < 10)
            out = new PrintWriter("../tests/0" + tNumber);
        else
            out = new PrintWriter("../tests/" + tNumber);
        out.println(n + " " + k);
        for (int i = 0; i < n; i++)
        	out.println(arr.get(i).x + " " + arr.get(i).y);

        out.close();
        testDescr.println("../tests/" + ((tNumber > 9) ? tNumber : ("0" + tNumber)) + ", folder=tests, subtask=subtask" + sb + ", points=0, comment=\"" + comment + "\"");
        tNumber++;        
    }
    
    static void genSample() throws FileNotFoundException {
        out = new PrintWriter("../preliminary/01");        
        out.println("6 6");
        out.println("12 2");
        out.println("10 3");
        out.println("3 1");
        out.println("5 4");
        out.println("7 2");
        out.println("9 1");	
        out.close();                
        testDescr.println("../preliminary/01, folder=preliminary, subtask=subtask0, points=0, comment=\"sample 1\"");
    }
    
    static int randFromTo(int l, int r) {
        return rnd.nextInt(r - l + 1) + l;      
    }

    static ArrayList<Pair> genPairs(int n, int mx) {
    	ArrayList<Pair> ans = new ArrayList<Pair>();
   		int have = n;
       	for (int i = 0; i * 2 < n; i++, have--) {
       		int a = randFromTo(0, mx);
       		int b = randFromTo(0, (int)Math.sqrt(mx));	
       		ans.add(new Pair(a, b));        		
       	}
       	for (int i = 0; i < have; i++) {
    		int m = randFromTo(0, 7);
    		int a = 0, b = 0;
    		if (m == 0) {
    		    a = 0; b = randFromTo(0, mx);    		     			
    		} else if (m == 1) {
    		    b = 0; a = randFromTo(0, mx);    		     			    		    		
    		} else {
    		      a = randFromTo(0, mx); b = randFromTo(0, mx);    		     			    		
    		}	
    		ans.add(new Pair(a, b));
       	}
       	Collections.shuffle(ans);
       	return ans;       
    }

	static ArrayList<Pair> genRandomPairs(int n, int mx) {
    	ArrayList<Pair> ans = new ArrayList<Pair>();
   		for (int i = 0; i < n; i++) {
       		int a = randFromTo(0, mx);
       		int b = randFromTo(0, mx);	
       		ans.add(new Pair(a, b));        		
       	}
       	Collections.shuffle(ans);
       	return ans;       
    }


    static void norm(ArrayList<Pair> arr) {
    	for (int i = 0; i < arr.size(); i++) {
    		int a = arr.get(i).x;
			int b = arr.get(i).y;
			if (b != 0) 
				a -= a % b;
			else 
				b = 1;
			arr.set(i, new Pair(a, b));
    	}
    }
    
        
    public static void main(String[] args) throws IOException {
        new File("../preliminary").mkdir();
        new File("../tests").mkdir();        
        testDescr = new PrintWriter("../tests.desc");
        genSample();
        {
            sb = 1;
            for (int i = 0; i < 10; i++) {
            	int n = randFromTo(50, 100);
            	int t = randFromTo(1, 1000);
            	ArrayList<Pair> arr = genPairs(n, 100000);
            	printTest(n, t, arr, "random test");
            }
            for (int i = 0; i < 2; i++) {
            	int n = randFromTo(50, 100);
            	int t = randFromTo(1, 1000);
            	ArrayList<Pair> arr = genRandomPairs(n, 100000);
            	printTest(n, t, arr, "very random test");
            }
            {
            	int n = 100;
            	int t = 1000;                          
            	ArrayList<Pair> arr1 = new ArrayList();
            	ArrayList<Pair> arr2 = new ArrayList();
				ArrayList<Pair> arr3 = new ArrayList();
            	for (int i = 0; i < n; ++i) {          
            		arr1.add(new Pair(100000, 100000));
            		arr2.add(new Pair(100000, 1));
            		arr3.add(new Pair(100000, 0));            	
            	}
            	printTest(n, t, arr1, "max test");
            	printTest(n, t, arr2, "max test");
            	printTest(n, t, arr3, "max test");
            
            }                                               
            testDescr.println("comment_subtask1=\"n &lt;= 100, t &lt;= 1000, a_i &lt;= 10^5, b_i &lt;= 10^5\"\nbonus_subtask1=20");
        }
        {
            sb = 2;
            for (int i = 0; i < 10; i++) {
            	int n = randFromTo(50, 100);
            	int t = randFromTo(1, 1000);
            	ArrayList<Pair> arr = genPairs(n, 1000000000);
            	printTest(n, t, arr, "random test");
            }
            for (int i = 0; i < 2; i++) {
            	int n = randFromTo(50, 100);
            	int t = randFromTo(1, 1000);
            	ArrayList<Pair> arr = genRandomPairs(n, 1000000000);
            	printTest(n, t, arr, "very random test");
            }
            {
            	int n = 100;
            	int t = 1000;                          
            	ArrayList<Pair> arr1 = new ArrayList();
            	ArrayList<Pair> arr2 = new ArrayList();
				ArrayList<Pair> arr3 = new ArrayList();
            	for (int i = 0; i < n; ++i) {          
            		arr1.add(new Pair(1000000000, 1000000000));
            		arr2.add(new Pair(1000000000, 1));
            		arr3.add(new Pair(1000000000, 0));            	
            	}
            	printTest(n, t, arr1, "max test");
            	printTest(n, t, arr2, "max test");
            	printTest(n, t, arr3, "max test");
            
            }                                                                                                        
            testDescr.println("comment_subtask2=\"n &lt;= 100, t &lt;= 1000\"\nbonus_subtask2=20");
        }
        {
            sb = 3;
            for (int i = 0; i < 5; i++) {
            	int n = randFromTo(1, 100000);
            	int t = randFromTo(1, 1000000);
            	ArrayList<Pair> arr = genPairs(n, 1000000000);
            	norm(arr);
            	printTest(n, t, arr, "random test");
            }
            for (int i = 0; i < 5; i++) {
            	int n = randFromTo(10000, 100000);
            	int t = randFromTo(100000, 1000000);
            	ArrayList<Pair> arr = genPairs(n, 1000000000);
            	norm(arr);
            	printTest(n, t, arr, "big random test");
            }

			for (int i = 0; i < 5; i++) {
            	int n = randFromTo(1, 100000);
            	int t = randFromTo(1, 1000000);
            	ArrayList<Pair> arr = genRandomPairs(n, 1000000000);
            	norm(arr);
            	printTest(n, t, arr, "very random test");
            }
            for (int i = 0; i < 5; i++) {
            	int n = randFromTo(10000, 100000);
            	int t = randFromTo(100000, 1000000);
            	ArrayList<Pair> arr = genRandomPairs(n, 1000000000);
            	norm(arr);
            	printTest(n, t, arr, "big very random test");
            }
            {
            	int n = 100000;
            	int t = 1000000;                          
            	ArrayList<Pair> arr1 = new ArrayList();
            	ArrayList<Pair> arr2 = new ArrayList();
				ArrayList<Pair> arr3 = new ArrayList();
            	for (int i = 0; i < n; ++i) {          
            		arr1.add(new Pair(1000000000, 1000000000));
            		arr2.add(new Pair(1000000000, 1));
            		arr3.add(new Pair(1000000000, 0));            	
            	}
            	printTest(n, t, arr1, "max test");
            	printTest(n, t, arr2, "max test");
            }                                                                                                        
                                                                                              
            testDescr.println("comment_subtask3=\"n &lt;= 10^5, t &lt;= 10^6, a_i % b_i == 0, b[i] > 0\"\nbonus_subtask3=40");
        }
        {
            sb = 4;
            for (int i = 0; i < 5; i++) {
            	int n = randFromTo(1, 100000);
            	int t = randFromTo(1, 1000000);
            	ArrayList<Pair> arr = genPairs(n, 1000000000);
            	printTest(n, t, arr, "random test");
            }
            for (int i = 0; i < 5; i++) {
            	int n = randFromTo(10000, 100000);
            	int t = randFromTo(100000, 1000000);
            	ArrayList<Pair> arr = genPairs(n, 1000000000);
            	printTest(n, t, arr, "big random test");
            }

			for (int i = 0; i < 5; i++) {
            	int n = randFromTo(1, 100000);
            	int t = randFromTo(1, 1000000);
            	ArrayList<Pair> arr = genRandomPairs(n, 1000000000);
            	printTest(n, t, arr, "very random test");
            }
            for (int i = 0; i < 5; i++) {
            	int n = randFromTo(10000, 100000);
            	int t = randFromTo(100000, 1000000);
            	ArrayList<Pair> arr = genRandomPairs(n, 1000000000);
            	printTest(n, t, arr, "big very random test");
            }
            {
            	int n = 100000;
            	int t = 1000000;                          
            	ArrayList<Pair> arr1 = new ArrayList();
            	ArrayList<Pair> arr2 = new ArrayList();
				ArrayList<Pair> arr3 = new ArrayList();
            	for (int i = 0; i < n; ++i) {          
            		arr1.add(new Pair(1000000000, 1000000000));
            		arr2.add(new Pair(1000000000, 1));
            		arr3.add(new Pair(1000000000, 0));            	
            	}
            	printTest(n, t, arr1, "max test");
            	printTest(n, t, arr2, "max test");
            	printTest(n, t, arr3, "max test");
            
            }                                                                                                                                                                                                                               
            testDescr.println("comment_subtask4=\"n &lt;= 10^5, t &lt;= 10^6\"\nbonus_subtask4=20");
        }

        testDescr.close();
    }                 
    private static class Pair {
    	int x, y;
    	Pair(int x, int y) {
    		this.x = x;
    		this.y = y;
    	}
    }

}
